/* This is auto-generated C header from LDmicro. Do not edit this file!
   Go back to the LDmicro ladder diagram source for changes in the ladder logic,
   and make any C additions in additional .c or .h files linked against this one. */
#ifndef __c_demo_H__
#define __c_demo_H__

#include "ladder.h"

// PLC cycle interval, set this according to LDmicro settings. (micro sec.)
#define PLC_INTERVAL 10000 // us

#include <EEPROM.h>
typedef BOOL ldBOOL;

extern void loopPlc(void);  // Call loopPlc() function in loop() of your arduino project
extern void setupPlc(void); //  or initialise PLC cycle timer in this function
extern void PlcCycle(void); //  and call PlcCycle() function once per PLC cycle timer.

void UART_Transmit(unsigned char data);
unsigned char UART_Receive(void);
ldBOOL UART_Receive_Avail(void);
ldBOOL UART_Transmit_Busy(void);

#define eeprom_busy_wait() do {} while(!eeprom_is_ready())

#ifdef USE_MACRO
    #define EEPROM_write( addr, x ) EEPROM.write(addr, x)
    #define EEPROM_read( addr ) EEPROM.read(addr)
#else
    void EEPROM_write(int addr, unsigned char data);
    unsigned char EEPROM_read(int addr);
#endif

// You provide I/O pin mapping for ARDUINO in ladder.h.
// See example lader_.h.

#define Read_I_b_rung_top() I_b_rung_top
#define Write_I_b_rung_top(x) I_b_rung_top = x
#define Write_I_b_rung_top_0() I_b_rung_top = 0
#define Write_I_b_rung_top_1() I_b_rung_top = 1

#define Read_I_b_oneShot_0000_PERSIST_saved() I_b_oneShot_0000_PERSIST_saved
#define Write_I_b_oneShot_0000_PERSIST_saved(x) I_b_oneShot_0000_PERSIST_saved = x
#define Write_I_b_oneShot_0000_PERSIST_saved_0() I_b_oneShot_0000_PERSIST_saved = 0
#define Write_I_b_oneShot_0000_PERSIST_saved_1() I_b_oneShot_0000_PERSIST_saved = 1

#define Read_I_b_scratch() I_b_scratch
#define Write_I_b_scratch(x) I_b_scratch = x
#define Write_I_b_scratch_0() I_b_scratch = 0
#define Write_I_b_scratch_1() I_b_scratch = 1

#define Read_I_b_oneShot_0001_ONE_SHOT_RISING_() I_b_oneShot_0001_ONE_SHOT_RISING_
#define Write_I_b_oneShot_0001_ONE_SHOT_RISING_(x) I_b_oneShot_0001_ONE_SHOT_RISING_ = x
#define Write_I_b_oneShot_0001_ONE_SHOT_RISING__0() I_b_oneShot_0001_ONE_SHOT_RISING_ = 0
#define Write_I_b_oneShot_0001_ONE_SHOT_RISING__1() I_b_oneShot_0001_ONE_SHOT_RISING_ = 1

#define Read_I_b_parOut_0000() I_b_parOut_0000
#define Write_I_b_parOut_0000(x) I_b_parOut_0000 = x
#define Write_I_b_parOut_0000_0() I_b_parOut_0000 = 0
#define Write_I_b_parOut_0000_1() I_b_parOut_0000 = 1

#define Read_I_b_parThis_0000() I_b_parThis_0000
#define Write_I_b_parThis_0000(x) I_b_parThis_0000 = x
#define Write_I_b_parThis_0000_0() I_b_parThis_0000 = 0
#define Write_I_b_parThis_0000_1() I_b_parThis_0000 = 1

#define Read_I_b_parOut_0001() I_b_parOut_0001
#define Write_I_b_parOut_0001(x) I_b_parOut_0001 = x
#define Write_I_b_parOut_0001_0() I_b_parOut_0001 = 0
#define Write_I_b_parOut_0001_1() I_b_parOut_0001 = 1

#define Read_I_b_parThis_0001() I_b_parThis_0001
#define Write_I_b_parThis_0001(x) I_b_parThis_0001 = x
#define Write_I_b_parThis_0001_0() I_b_parThis_0001 = 0
#define Write_I_b_parThis_0001_1() I_b_parThis_0001 = 1


#ifndef NO_PROTOTYPES
// LDmicro provide these functions.
#ifdef USE_MACRO
    #define Read_U_b_Ycycle2() digitalRead(pin_U_b_Ycycle2)
    #define Write_U_b_Ycycle2_0() digitalWrite(pin_U_b_Ycycle2, LOW)
    #define Write_U_b_Ycycle2_1() digitalWrite(pin_U_b_Ycycle2, HIGH)
    #define Write_U_b_Ycycle2(b) ( (b) ? Write_U_b_Ycycle2_1() : Write_U_b_Ycycle2_0() )
#else
    ldBOOL Read_U_b_Ycycle2(void);
    void Write_U_b_Ycycle2(ldBOOL b);
    void Write_U_b_Ycycle2_1(void);
    void Write_U_b_Ycycle2_0(void);
#endif
#endif

#ifndef NO_PROTOTYPES
// LDmicro provide this function.
#ifdef USE_MACRO
    #define Read_U_b_Xled() digitalRead(pin_U_b_Xled)
#else
    ldBOOL Read_U_b_Xled(void);
#endif
#endif

#ifndef NO_PROTOTYPES
// LDmicro provide this function.
#ifdef USE_MACRO
    #define Read_U_b_ADCvalue() analogRead(pin_U_b_ADCvalue)
#else
    SDWORD Read_U_b_ADCvalue(void);
#endif
#endif

#ifndef NO_PROTOTYPES
// LDmicro provide this function.
#ifdef USE_MACRO
    #define Write_U_b_PWMduty(x) analogWrite(pin_U_b_PWMduty, x)
#else
    void Write_U_b_PWMduty(SDWORD x);
#endif
#endif

#define Read_U_b_RUpdate() U_b_RUpdate
#define Write_U_b_RUpdate(x) U_b_RUpdate = x
#define Write_U_b_RUpdate_0() U_b_RUpdate = 0
#define Write_U_b_RUpdate_1() U_b_RUpdate = 1

#define Read_I_b_TUpdateOF_antiglitch() I_b_TUpdateOF_antiglitch
#define Write_I_b_TUpdateOF_antiglitch(x) I_b_TUpdateOF_antiglitch = x
#define Write_I_b_TUpdateOF_antiglitch_0() I_b_TUpdateOF_antiglitch = 0
#define Write_I_b_TUpdateOF_antiglitch_1() I_b_TUpdateOF_antiglitch = 1

#define Read_I_b_parThis_0002() I_b_parThis_0002
#define Write_I_b_parThis_0002(x) I_b_parThis_0002 = x
#define Write_I_b_parThis_0002_0() I_b_parThis_0002 = 0
#define Write_I_b_parThis_0002_1() I_b_parThis_0002 = 1


#ifndef NO_PROTOTYPES
// LDmicro provide these functions.
#ifdef USE_MACRO
    #define Read_U_b_YUpdate() digitalRead(pin_U_b_YUpdate)
    #define Write_U_b_YUpdate_0() digitalWrite(pin_U_b_YUpdate, LOW)
    #define Write_U_b_YUpdate_1() digitalWrite(pin_U_b_YUpdate, HIGH)
    #define Write_U_b_YUpdate(b) ( (b) ? Write_U_b_YUpdate_1() : Write_U_b_YUpdate_0() )
#else
    ldBOOL Read_U_b_YUpdate(void);
    void Write_U_b_YUpdate(ldBOOL b);
    void Write_U_b_YUpdate_1(void);
    void Write_U_b_YUpdate_0(void);
#endif
#endif

#define Read_I_b_oneShot_0002_ONE_SHOT_RISING_() I_b_oneShot_0002_ONE_SHOT_RISING_
#define Write_I_b_oneShot_0002_ONE_SHOT_RISING_(x) I_b_oneShot_0002_ONE_SHOT_RISING_ = x
#define Write_I_b_oneShot_0002_ONE_SHOT_RISING__0() I_b_oneShot_0002_ONE_SHOT_RISING_ = 0
#define Write_I_b_oneShot_0002_ONE_SHOT_RISING__1() I_b_oneShot_0002_ONE_SHOT_RISING_ = 1

#define Read_I_b_parThis_0003() I_b_parThis_0003
#define Write_I_b_parThis_0003(x) I_b_parThis_0003 = x
#define Write_I_b_parThis_0003_0() I_b_parThis_0003 = 0
#define Write_I_b_parThis_0003_1() I_b_parThis_0003 = 1


#ifndef NO_PROTOTYPES
// LDmicro provide these functions.
#ifdef USE_MACRO
    #define Read_U_b_YTEMP_HI() digitalRead(pin_U_b_YTEMP_HI)
    #define Write_U_b_YTEMP_HI_0() digitalWrite(pin_U_b_YTEMP_HI, LOW)
    #define Write_U_b_YTEMP_HI_1() digitalWrite(pin_U_b_YTEMP_HI, HIGH)
    #define Write_U_b_YTEMP_HI(b) ( (b) ? Write_U_b_YTEMP_HI_1() : Write_U_b_YTEMP_HI_0() )
#else
    ldBOOL Read_U_b_YTEMP_HI(void);
    void Write_U_b_YTEMP_HI(ldBOOL b);
    void Write_U_b_YTEMP_HI_1(void);
    void Write_U_b_YTEMP_HI_0(void);
#endif
#endif

#define Read_I_b_oneShot_0003_FMTD_STR_() I_b_oneShot_0003_FMTD_STR_
#define Write_I_b_oneShot_0003_FMTD_STR_(x) I_b_oneShot_0003_FMTD_STR_ = x
#define Write_I_b_oneShot_0003_FMTD_STR__0() I_b_oneShot_0003_FMTD_STR_ = 0
#define Write_I_b_oneShot_0003_FMTD_STR__1() I_b_oneShot_0003_FMTD_STR_ = 1

#define Read_I_b_fmtdStr_0003_doSend() I_b_fmtdStr_0003_doSend
#define Write_I_b_fmtdStr_0003_doSend(x) I_b_fmtdStr_0003_doSend = x
#define Write_I_b_fmtdStr_0003_doSend_0() I_b_fmtdStr_0003_doSend = 0
#define Write_I_b_fmtdStr_0003_doSend_1() I_b_fmtdStr_0003_doSend = 1

#define Read_I_b_fmtdStr_0002_isLeadingZero() I_b_fmtdStr_0002_isLeadingZero
#define Write_I_b_fmtdStr_0002_isLeadingZero(x) I_b_fmtdStr_0002_isLeadingZero = x
#define Write_I_b_fmtdStr_0002_isLeadingZero_0() I_b_fmtdStr_0002_isLeadingZero = 0
#define Write_I_b_fmtdStr_0002_isLeadingZero_1() I_b_fmtdStr_0002_isLeadingZero = 1

#define Read_I_b_parThis_0004() I_b_parThis_0004
#define Write_I_b_parThis_0004(x) I_b_parThis_0004 = x
#define Write_I_b_parThis_0004_0() I_b_parThis_0004 = 0
#define Write_I_b_parThis_0004_1() I_b_parThis_0004 = 1

#define Read_I_b_oneShot_0004_ONE_SHOT_FALLING_() I_b_oneShot_0004_ONE_SHOT_FALLING_
#define Write_I_b_oneShot_0004_ONE_SHOT_FALLING_(x) I_b_oneShot_0004_ONE_SHOT_FALLING_ = x
#define Write_I_b_oneShot_0004_ONE_SHOT_FALLING__0() I_b_oneShot_0004_ONE_SHOT_FALLING_ = 0
#define Write_I_b_oneShot_0004_ONE_SHOT_FALLING__1() I_b_oneShot_0004_ONE_SHOT_FALLING_ = 1

#define Read_I_b_oneShot_0005_FMTD_STR_() I_b_oneShot_0005_FMTD_STR_
#define Write_I_b_oneShot_0005_FMTD_STR_(x) I_b_oneShot_0005_FMTD_STR_ = x
#define Write_I_b_oneShot_0005_FMTD_STR__0() I_b_oneShot_0005_FMTD_STR_ = 0
#define Write_I_b_oneShot_0005_FMTD_STR__1() I_b_oneShot_0005_FMTD_STR_ = 1

#define Read_I_b_fmtdStr_0007_doSend() I_b_fmtdStr_0007_doSend
#define Write_I_b_fmtdStr_0007_doSend(x) I_b_fmtdStr_0007_doSend = x
#define Write_I_b_fmtdStr_0007_doSend_0() I_b_fmtdStr_0007_doSend = 0
#define Write_I_b_fmtdStr_0007_doSend_1() I_b_fmtdStr_0007_doSend = 1

#define Read_I_b_fmtdStr_0006_isLeadingZero() I_b_fmtdStr_0006_isLeadingZero
#define Write_I_b_fmtdStr_0006_isLeadingZero(x) I_b_fmtdStr_0006_isLeadingZero = x
#define Write_I_b_fmtdStr_0006_isLeadingZero_0() I_b_fmtdStr_0006_isLeadingZero = 0
#define Write_I_b_fmtdStr_0006_isLeadingZero_1() I_b_fmtdStr_0006_isLeadingZero = 1

#define Read_I_b_oneShot_0006_ONE_SHOT_FALLING_() I_b_oneShot_0006_ONE_SHOT_FALLING_
#define Write_I_b_oneShot_0006_ONE_SHOT_FALLING_(x) I_b_oneShot_0006_ONE_SHOT_FALLING_ = x
#define Write_I_b_oneShot_0006_ONE_SHOT_FALLING__0() I_b_oneShot_0006_ONE_SHOT_FALLING_ = 0
#define Write_I_b_oneShot_0006_ONE_SHOT_FALLING__1() I_b_oneShot_0006_ONE_SHOT_FALLING_ = 1

#define Read_I_b_oneShot_0007_FMTD_STR_() I_b_oneShot_0007_FMTD_STR_
#define Write_I_b_oneShot_0007_FMTD_STR_(x) I_b_oneShot_0007_FMTD_STR_ = x
#define Write_I_b_oneShot_0007_FMTD_STR__0() I_b_oneShot_0007_FMTD_STR_ = 0
#define Write_I_b_oneShot_0007_FMTD_STR__1() I_b_oneShot_0007_FMTD_STR_ = 1

#define Read_I_b_fmtdStr_000b_doSend() I_b_fmtdStr_000b_doSend
#define Write_I_b_fmtdStr_000b_doSend(x) I_b_fmtdStr_000b_doSend = x
#define Write_I_b_fmtdStr_000b_doSend_0() I_b_fmtdStr_000b_doSend = 0
#define Write_I_b_fmtdStr_000b_doSend_1() I_b_fmtdStr_000b_doSend = 1

#define Read_I_b_fmtdStr_000a_isLeadingZero() I_b_fmtdStr_000a_isLeadingZero
#define Write_I_b_fmtdStr_000a_isLeadingZero(x) I_b_fmtdStr_000a_isLeadingZero = x
#define Write_I_b_fmtdStr_000a_isLeadingZero_0() I_b_fmtdStr_000a_isLeadingZero = 0
#define Write_I_b_fmtdStr_000a_isLeadingZero_1() I_b_fmtdStr_000a_isLeadingZero = 1

#define Read_I_b_oneShot_0008_ONE_SHOT_FALLING_() I_b_oneShot_0008_ONE_SHOT_FALLING_
#define Write_I_b_oneShot_0008_ONE_SHOT_FALLING_(x) I_b_oneShot_0008_ONE_SHOT_FALLING_ = x
#define Write_I_b_oneShot_0008_ONE_SHOT_FALLING__0() I_b_oneShot_0008_ONE_SHOT_FALLING_ = 0
#define Write_I_b_oneShot_0008_ONE_SHOT_FALLING__1() I_b_oneShot_0008_ONE_SHOT_FALLING_ = 1

#endif

